#region Info
/* 
 * Routine originally coded by Apoc and then I tweaked it for me.
  */
#endregion

using System;
using System.Collections.Generic;
using System.Linq;
using Styx;
using Styx.Common;
using Styx.CommonBot;
using Styx.CommonBot.Routines;
using Styx.Helpers;
using Styx.TreeSharp;
using Styx.WoWInternals;
using Styx.WoWInternals.WoWObjects;
using Action = Styx.TreeSharp.Action;
using CommonBehaviors.Actions;
using System.Runtime.InteropServices;
using System.Windows.Forms;

namespace Warena
{
    public partial class Routine : CombatRoutine
    {
        public override string Name { get { return "Warena"; } }
        public override WoWClass Class { get { return WoWClass.Warrior; } }
        public Composite _combat, _buffs;
        public override Composite CombatBehavior { get { return _combat; } }
        public override Composite PreCombatBuffBehavior { get { return _buffs; } }
        public override Composite CombatBuffBehavior { get { return _buffs; } }

        public override void Initialize()
        {
            
            //Lua.DoString("RunMacroText(\"/script SetCVar('autoInteract', '0')")");
            
            _buffs = CreateBuffs();

            if (SpellManager.HasSpell("Mortal Strike"))
            {
                _combat = CreateArms();
                Logging.Write("CreateArms()");
            }
            if (SpellManager.HasSpell("Shield Slam"))
            {
                _combat = CreateProt();
                Logging.Write("CreateProt()");
            }
            
           
            //if (SpellManager.HasSpell("Bloodthirst"))
            //{
            //    _combat = CreateFury();
            //    Logging.Write("CreateFury()");
            //}
        }

        Composite CreateBuffs() 
        {
            //return Cast("Battle Shout", ret => !StyxWoW.Me.HasAura(aw"Battle Shout"));
            return Hotkeys();
        }

        Composite CreateArms()
        {
            return new PrioritySelector(

            #region HOTKEYS
               Hotkeys(),
            #endregion
            #region DEFENSE
                UseHealthstone(),
                DieByTheSword(),
                VictoryRush(),
                Disarm(),
                RallyingCry(),
                DemoralizingBannerMe(),
                DemoralizingBannerFriend(),
                MockingBanner(),
                DefensiveStance(),
                Safeguard(),
                SafeguardScatterShot(),
                HeroicLeapOnScatter(),
            #endregion
            #region SITUATIONAL
                BattleShout(),
                BattleStance(),
                BattleShoutSF(),
                BerserkerRageForSF(),
                ShatteringThrow(),
            #endregion
            #region INTERRUPTS
                Interrupts(),
                HeroicLeapCC(),
                SpellReflectAuto(),
                //MassSpellReflectAuto(),
            #endregion
            #region RANGED
                //HeroicThrow(),
                //Throw(),
                //HeroicThrowTotems(),
            #endregion
            #region AOE
                SweepingStrikes(),
                //Cleave(),
            #endregion
            #region COMBAT
                Equip2H(),
                Execute(),
                    new Decorator(ret => 
                        StyxWoW.Me.CurrentTarget != null && 
                        StyxWoW.Me.CurrentTarget.IsWithinMeleeRange &&
                        IsAttackable(StyxWoW.Me.CurrentTarget) && 
                        !IsImmune(StyxWoW.Me.CurrentTarget) && 
                        !IsInCC(StyxWoW.Me.CurrentTarget),

                        new PrioritySelector(
                            //Cast("Execute"),
                            Hamstring(),
                            Cast("Heroic Strike", ret => StyxWoW.Me.RagePercent >= 90),
                            Cast("Mortal Strike", ret => StyxWoW.Me.RagePercent <= 89 || !StyxWoW.Me.HasAura("Mortal Wounds")),
                            Cast("Colossus Smash"),
                            //Cast("Cleave", ret => EnableGlyphofOverpower && EnemyUnitsInMelee.Count() > 1 && !StyxWoW.Me.HasAura("Glyph of Overpower")), //115940 - Glyph of Overpower
                            Cast("Overpower"),
                            Cast("Slam", ret => StyxWoW.Me.RagePercent >= 50)
                        )
                    )
                #endregion
            );
        }
        Composite CreateProt() {
            return new PrioritySelector(
            #region DEFENSE
                UseHealthstone(),
                VictoryRush(),
                DieByTheSword(),
                Disarm(),
                RallyingCry(),
                DemoralizingBannerMe(),
                DemoralizingBannerFriend(),
                MockingBanner(),
            #endregion
            #region SITUATIONAL
                //Equip2H(),
                //BattleStance(),
                SpellReflect(),
                //MassSpellReflect(),
                BattleShoutSF(),
                BerserkerRageForSF(),
                ShatteringThrow(),
            #endregion
            #region INTERRUPTS
                //Pummel(),
                //Shockwave(),
                //DisruptingShout(),
            #endregion
            #region RANGED
                HeroicThrow(),
                Throw(),
            #endregion
            #region EXECUTE
                BattleShout(),
                Execute(),
            #endregion
            #region AOE
                new Decorator(ret =>
                    //UnfriendlyUnits.Count() != null &&
                    IsAttackable(StyxWoW.Me.CurrentTarget) &&
                    EnemyUnitsInMelee.Count() >= 2 &&
                    EnemyCCInMelee.Count() < 1 &&
                    StyxWoW.Me.CurrentTarget.IsWithinMeleeRange,
                        new PrioritySelector(
                            Cast("Sweeping Strikes"),
                            Cast("Cleave", ret => StyxWoW.Me.RagePercent > 50),
                            Cast("Whirlwind", ret => EnemyUnitsInMelee.Count() >= 4 && StyxWoW.Me.RagePercent > 75)
                            //Cast("Thunder Clap", ret => UnfriendlyUnits.Count() >= 4 && StyxWoW.Me.RagePercent > 75),
                        )
                    ),
            #endregion
            //Need ThunderClap()
            //Need HeroicStrike()
            #region COMBAT
                    Hamstring(),
                    HeroicStrikeUltimatum(),
                    ShieldSlam(),
                    Revenge(),
                    Devastate(),
                    HeroicStrikeDeadlyCalm(),
                    DemoralizingShout(),
                    ShieldBlock(),
                    ShieldBarrier()

            #endregion
            );
        }
        Composite CreateFury() {
            return new PrioritySelector(
                //FURY
            );
        }
    }
}